Package: geb.download

## [Groovy] Interface DownloadSupport

-     interface DownloadSupport

- - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `abstract HttpURLConnection` | `download()` Creates a http url connection to a url, that has the same cookies as the browser.
    `` | `abstract HttpURLConnection` | `download(Map options)` Creates a http url connection to a url, that has the same cookies as the browser.
    `` | `abstract HttpURLConnection` | `download(String uri)` Calls download with the single option '`uri`' as the given value.
    `` | `abstract byte[]` | `downloadBytes()` Opens a url connection via download(Map) by passing an empty Map and returns the raw bytes.
    `` | `abstract byte[]` | `downloadBytes(Map options)` Opens a url connection via download(Map) and returns the raw bytes.
    `` | `abstract byte[]` | `downloadBytes(Map options, Closure connectionConfig)` Opens a url connection via download(Map) and returns the raw bytes.
    `` | `abstract byte[]` | `downloadBytes(Closure connectionConfig)` Opens a url connection via download(Map) and returns the raw bytes.
    `` | `abstract byte[]` | `downloadBytes(String uri)` Opens a url connection via download(String) and returns the raw bytes.
    `` | `abstract byte[]` | `downloadBytes(String uri, Closure connectionConfig)` Opens a url connection via download(String) and returns the raw bytes.
    `` | `abstract Object` | `downloadContent()` Opens a url connection via download(Map) by passing an empty Map and returns the content object.
    `` | `abstract Object` | `downloadContent(Map options)` Opens a url connection via download(Map) and returns the content object.
    `` | `abstract Object` | `downloadContent(Map options, Closure connectionConfig)` Opens a url connection via download(Map) and returns the content object.
    `` | `abstract Object` | `downloadContent(String uri)` Opens a url connection via download(String) and returns the content object.
    `` | `abstract Object` | `downloadContent(String uri, Closure connectionConfig)` Opens a url connection via download(String) and returns the content object.
    `` | `abstract Object` | `downloadContent(Closure connectionConfig)` Opens a url connection via download(String) and returns the content object.
    `` | `abstract InputStream` | `downloadStream()` Opens a url connection via download(Map) using an empty Map and returns the response input stream.
    `` | `abstract InputStream` | `downloadStream(Map options)` Opens a url connection via download(Map) and returns the response input stream.
    `` | `abstract InputStream` | `downloadStream(Map options, Closure connectionConfig)` Opens a url connection via download(Map) and returns the response input stream.
    `` | `abstract InputStream` | `downloadStream(String uri)` Opens a url connection via download(String) and returns the response input stream.
    `` | `abstract InputStream` | `downloadStream(String uri, Closure connectionConfig)` Opens a url connection via download(String) and returns the response input stream.
    `` | `abstract InputStream` | `downloadStream(Closure connectionConfig)` Opens a url connection via download(Map) and returns the response input stream.
    `` | `abstract String` | `downloadText()` Opens a url connection via download(Map) and returns the response text, if the content type was textual.
    `` | `abstract String` | `downloadText(Map options)` Opens a url connection via download(Map) and returns the response text, if the content type was textual.
    `` | `abstract String` | `downloadText(Map options, Closure connectionConfig)` Opens a url connection via download(Map) and returns the response text, if the content type was textual.
    `` | `abstract String` | `downloadText(String uri)` Opens a url connection via download(String) and returns the response text, if the content type was textual.
    `` | `abstract String` | `downloadText(String uri, Closure connectionConfig)` Opens a url connection via download(String) and returns the response text, if the content type was textual.
    `` | `abstract String` | `downloadText(Closure connectionConfig)` Opens a url connection via download(Map) and returns the response text, if the content type was textual.

- - ### Method Detail

    - #### abstract HttpURLConnection download()

      Creates a http url connection to a url, that has the same cookies as the browser. Resolves the base and the uri to the current browser page

    - #### abstract HttpURLConnection download(Map options)

      Creates a http url connection to a url, that has the same cookies as the browser.

      Valid options are:

      - `uri` - the uri to resolve relative to the base option (current browser page used if `null`)
      - `base` - what to resolve the uri against (current browser page used if `null`)

    - #### abstract HttpURLConnection download(String uri)

      Calls download with the single option '`uri`' as the given value.

    - #### abstract byte[] downloadBytes()

      Opens a url connection via download(Map) by passing an empty Map and returns the raw bytes.

    - #### abstract byte[] downloadBytes(Map options)

      Opens a url connection via download(Map) and returns the raw bytes.

    - #### abstract byte[] downloadBytes(Map options, Closure connectionConfig)

      Opens a url connection via download(Map) and returns the raw bytes.

      If connectionConfig is given, it is called with the HttpURLConnection before the request is made.

    - #### abstract byte[] downloadBytes(Closure connectionConfig)

      Opens a url connection via download(Map) and returns the raw bytes.

      connectionConfig is called with the HttpURLConnection before the request is made.

    - #### abstract byte[] downloadBytes(String uri)

      Opens a url connection via download(String) and returns the raw bytes.

    - #### abstract byte[] downloadBytes(String uri, Closure connectionConfig)

      Opens a url connection via download(String) and returns the raw bytes.

      If connectionConfig is given, it is called with the HttpURLConnection before the request is made.

    - #### abstract Object downloadContent()

      Opens a url connection via download(Map) by passing an empty Map and returns the content object.

    - #### abstract Object downloadContent(Map options)

      Opens a url connection via download(Map) and returns the content object.

    - #### abstract Object downloadContent(Map options, Closure connectionConfig)

      Opens a url connection via download(Map) and returns the content object.

      If connectionConfig is given, it is called with the HttpURLConnection before the request is made.

      See Also:
        URLConnection.getContent

    - #### abstract Object downloadContent(String uri)

      Opens a url connection via download(String) and returns the content object.

    - #### abstract Object downloadContent(String uri, Closure connectionConfig)

      Opens a url connection via download(String) and returns the content object.

      If connectionConfig is given, it is called with the HttpURLConnection before the request is made.

      See Also:
        URLConnection.getContent

    - #### abstract Object downloadContent(Closure connectionConfig)

      Opens a url connection via download(String) and returns the content object.

      connectionConfig is called with the HttpURLConnection before the request is made.

      See Also:
        URLConnection.getContent

    - #### abstract InputStream downloadStream()

      Opens a url connection via download(Map) using an empty Map and returns the response input stream.

    - #### abstract InputStream downloadStream(Map options)

      Opens a url connection via download(Map) and returns the response input stream.

    - #### abstract InputStream downloadStream(Map options, Closure connectionConfig)

      Opens a url connection via download(Map) and returns the response input stream.

      If connectionConfig is given, it is called with the HttpURLConnection before the request is made.

    - #### abstract InputStream downloadStream(String uri)

      Opens a url connection via download(String) and returns the response input stream.

    - #### abstract InputStream downloadStream(String uri, Closure connectionConfig)

      Opens a url connection via download(String) and returns the response input stream.

      If connectionConfig is given, it is called with the HttpURLConnection before the request is made.

    - #### abstract InputStream downloadStream(Closure connectionConfig)

      Opens a url connection via download(Map) and returns the response input stream.

      connectionConfig is called with the HttpURLConnection before the request is made.

    - #### abstract String downloadText()

      Opens a url connection via download(Map) and returns the response text, if the content type was textual.

    - #### abstract String downloadText(Map options)

      Opens a url connection via download(Map) and returns the response text, if the content type was textual.

    - #### abstract String downloadText(Map options, Closure connectionConfig)

      Opens a url connection via download(Map) and returns the response text, if the content type was textual.

      If connectionConfig is given, it is called with the HttpURLConnection before the request is made.

    - #### abstract String downloadText(String uri)

      Opens a url connection via download(String) and returns the response text, if the content type was textual.

    - #### abstract String downloadText(String uri, Closure connectionConfig)

      Opens a url connection via download(String) and returns the response text, if the content type was textual.

      If connectionConfig is given, it is called with the HttpURLConnection before the request is made.

    - #### abstract String downloadText(Closure connectionConfig)

      Opens a url connection via download(Map) and returns the response text, if the content type was textual.

      connectionConfig is called with the HttpURLConnection before the request is made.